azma/urls.py
from django.conf.urls import patterns, include, url
from django.contrib import admin
from django.contrib.staticfiles.urls import staticfiles_urlpatterns

from azma import views


admin.autodiscover()

urlpatterns = patterns('',
                       # Examples:
                       # url(r'^$', 'azma.views.home', name='home'),
                       # url(r'^blog/', include('blog.urls')),
                       url(r'^tinymce/', include('tinymce.urls')),
                       url(r'^cms/', include('azma_cms.urls')),
                       url(r'^blog/', include('elephantblog.urls')),
                       url(r'^comments/', include('django.contrib.comments.urls')),
                       url(r'^(?i)admin/', include(admin.site.urls)),
                       url(r'^(?i)about', views.about, name='about'),
                       url(r'^(?i)user/', include('user.urls')),
                       url(r'^(?i)profile', include('user_profile.urls', namespace='profile')),
                       url(r'^(?i)wage_meter/', include('wage_meter.urls', namespace='wages')),
                       url(r'^(?i)answer/', include('answer.urls', namespace='answer')),
                       url(r'^(?i)tutorial/', include('tutorial.urls', namespace='tutorial')),
                       url(r'^', include('exam.urls', namespace='exam')),
)

urlpatterns += staticfiles_urlpatterns()

exam/urls.py
from django.conf.urls import patterns, url
from exam import views

urlpatterns = patterns('',
                       url(r'^(?i)$', views.index, name='index'),
                       url(r'^(?i)what$', views.what, name='what'),
                       url(r'^exam/(?i)(?P<exam_id>\d*)', views.intro, name='intro'),
                       url(r'^start/(?i)(?P<exam_id>\d*)', views.start, name='start'),
                       url(r'^(?i)cat/(?P<category_id>\d*)', views.sub_categories, name='sub_categories')
)

user_profile/urls.py
from django.conf.urls import patterns, url
from django.contrib.auth.decorators import login_required
from user_profile import views

__author__ = 'soroosh'

urlpatterns = patterns('',
                       url(r'^(?i)$', login_required(views.ProfileView.as_view()), name='show_profile'),
                       url(r'^(?i)/changepass$', views.change_password, name='change_password'),
                       )

user_profile/models.py
from django.db import models

from django.contrib.auth.models import User
from django.db import models
from django.db.models.signals import post_save
from exam.models import Exam
import hashlib

# ################################
class UserProfile(models.Model):
    user = models.OneToOneField(User, related_name='profile')

    def email_md5(self):

        hashlib.md5
        return str(hashlib.md5(self.user.email.lower()).hexdigest())


def create_user_profile(sender, instance, created, **kwargs):
    if created:
        UserProfile.objects.get_or_create(user=instance)


post_save.connect(create_user_profile, sender=User)

#################################

class RegisteredExam(models.Model):
    exam = models.ForeignKey(Exam)
    registeration_date = models.DateTimeField()
    is_done = models.BooleanField()

    user_profile = models.ForeignKey(UserProfile, related_name='registered_exams')

user_profile/views.py
from django.contrib.auth import authenticate
from django.contrib.auth.decorators import login_required
from django.db.models import Sum
from django.http.response import HttpResponse
from django.template import loader
from django.template.context import RequestContext
from django.utils.translation import ugettext_lazy as _
from django.views.generic import View
from answer.models import ExamAnswerHistory, ExamAnswer
from exam.models import ExamCategory, Exam

profile_template = loader.get_template('profile.html')


class ProfileView(View):
    def get(self, request):
        profile_template = loader.get_template('profile.html')
        categories = ExamCategory.objects.all()
        exam_answers = ExamAnswer.objects.filter(user__id=request.user.id)
        # exam_answers = ExamAnswerHistory.objects.filter(user__id=request.user.id)
        # exam_categories = list(ExamCategory.objects.filter(exam__examanswer__user=request.user.id))
        # sum_score = 0
        # for category in exam_categories:
        # category.answers = list(ExamAnswer.objects.filter(user__id=request.user.id, exam__category=category.id))
        # category.sum_score = 0
        # for answer in category.answers:
        #     category.sum_score += answer.score

        # for a in exam_answers:
        #     sum_score += a.score()

        context = RequestContext(request,
                                 {'categories': categories,
                                  # 'sum_score': sum_score, 'exam_categories': exam_categories,
                                  'exam_answers': exam_answers
                                 })
        return HttpResponse(profile_template.render(context))


@login_required(login_url='/user/login')
def change_password(request):
    if request.method == "POST":
        oldPass = request.POST["oldPass"]
        newPass = request.POST["newPass"]

        if request.user.check_password(oldPass):
            request.user.set_password(newPass)
            request.user.save()
            context = RequestContext(request, {'message': _('password has been changed')})

            return HttpResponse(profile_template.render(context))
        else:
            return HttpResponse("!!!!!")

    else:
        return HttpResponse(profile_template.render(RequestContext(request)))

user_profile/templates/profile.html
{% extends 'base.html' %}
{% load i18n %}
{% load staticfiles %}
{% load compress %}

{% block title %}صفحه شخصی {% endblock %}


{% block css %}

    <style>
        .profile-item {
            cursor: pointer;
            border-right:1pt transparent solid;
            border-left:1pt transparent solid;
        }

        .profile-item:hover {
            opacity: 0.9;
            border-left:1pt #fff solid;
            border-right:1pt #fff solid;
        }

        .profile-item-selected:hover {
            cursor: auto;
        }
    </style>
{% endblock %}
{% block no_container_content %}





    {#    <div class="user-panel">#}
    {#        <div class="panel-handle panel-handle-opened">#}
    {#            <div class="panel-handle-arm ">#}
    {#                <div class="arm-pointer glyphicon glyphicon-chevron-right"></div>#}
    {#            </div>#}
    {##}
    {#        </div>#}

    <div class="row" style="margin: 30px;">
        <div class="page-header">

            <h3> صفحه شخصی {{ user.username }}</h3>
        </div>
    </div>
    <div class="row" style="margin:0px; padding-right: 0px;">
        <div id="profile-menu" class="col-xs-2 well hidden-sm hidden-xs hidden-md hidden-print"
             style="">

            {#            <div class="col-xs-12" style="padding-right: 2px; padding-left: 0; padding-top:8px;" id="profile-menu">#}
            <div class="profile-item profile-item-selected" id="info">
                اطلاعات من
            </div>
{#            <div class="profile-item" id="exam">#}
{#                آزمونها#}
{#            </div>#}
            <div class="profile-item" id="password">
                تغییر رمز عبور
            </div>
            {#            </div>#}
        </div>

        <div class="col-xs-9 pull-right profile-content"
             style="padding-right: 30px;margin-right: 20px; padding-left: 30px;"
                >
            <div class="visible" id="info-container">
                <div class="row">

                    <div class="col-lg-2">نام</div>
                    <div class="col-lg-10">{{ user.first_name }}</div>
                </div>
                <div class="row">
                    <div class="col-lg-2">نام خانوادگی</div>
                    <div class="col-lg-10">{{ user.last_name }}</div>
                </div>
                <div class="row">
                    <div class="col-lg-2">نام کاربری</div>
                    <div class="col-lg-10">{{ user.username }}</div>
                </div>
                <div class="row">
                    <div class="col-lg-2"> تاریخ عضویت</div>
                    <div class="col-lg-10">{{ user.date_joined }}</div>
                </div>

            </div>
            <div class=" c hidden" id="exam-container">
                <div>
                    <ul id="myTab" class="nav nav-tabs">
                        {% for category in categories %}
                            <li class="">
                                {% with "image/techs/"|add:category.name|add:".png" as address %}
                                    <a data-toggle="tab" style="height: 60px;" href="#{{ category.local_name }}"><img
                                            class="img-responsive" style="height: 40px;"
                                            src="{% static address %}"/>
                                    </a>
                                {% endwith %}
                            </li>
                        {% endfor %}
                    </ul>
                    <div class="tab-content" style="font-size: 1.1vw; border: solid 1px #448899;">
                        {% for category in categories %}
                            <div class="tab-pane" id="{{ category.local_name }}">
                                {% for sub in category.sub_categories.all %}
                                    <div class="jumbotron"
                                         style="padding-top: 10px; padding-bottom: 10px; margin-bottom: 0px; border-bottom: 0px;">
                                        <div class="row">
                                            <div class="col-xs-10">
                                                {{ sub.local_name }}
                                            </div>
                                            <div class="col-xs-1 pull-left "
                                                 style="text-align: left; padding-left: 0px;">
                                                <span style="vertical-align: middle; margin-top: 11px;"
                                                      class="badge">{{ sub.exam_set.count }}
                                                </span>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="row" style="padding-right: 2%; font-size: 1vw;">
                                        {% for exam in sub.exam_set.all %}
                                            <div class="col-xs-3"
                                                 style="padding-top: 25px; border:solid 1px transparent; border-radius: 5px; background-color:#E0E0E0;margin:20px; min-height: 200px; text-align: center; ">
                                                <a style="margin-top: 4%; font-size: 1.1vw;"
                                                   href="{% url 'exam:intro' exam.id %}"> {{ exam.local_name }} </a>

                                                <div style="padding-top: 10px;">
                                                    امتیاز شما:
                                                    <div id="{{ exam.id }}">
                                                        شمار در این آزمون شرکت نکرده اید
                                                    </div>
                                                </div>
                                            </div>
                                        {% endfor %}
                                    </div>

                                {% endfor %}

                            </div>

                        {% endfor %}
                    </div>

                </div>
            </div>

            <div class="c hidden col-xs-9" id="password-container">
                <form method="post" action="{% url 'profile:change_password' %}">
                    {% csrf_token %}

                    <div class="control-group"><label class="form-label">

                        رمز عبور کنونی

                    </label>

                        <div class="controls">
                            <label></label>
                            <input type="password" class="form-control" name="oldPass"/>
                        </div>
                    </div>
                    <div class="control-group">
                        <label class="form-label">
                            رمز عبور جدید
                        </label>

                        <div class="controls">
                            <label></label>
                            <input type="password" class="form-control" name="newPass"/>
                        </div>
                    </div>
                    <div class="control-group">
                        <label class="form-label">
                            تکرار رمز عبور
                        </label>

                        <div class="controls">
                            <label></label>
                            <input type="password" class="form-control"/>
                        </div>
                    </div>
                    <button style="margin-top: 10px;" type="submit" class="btn btn-gentel btn-lg">
                        ثبت
                    </button>
                </form>
            </div>
        </div>
    </div>
    </div>


{% endblock %}

{% block js %}



    <script type="text/javascript">
        var user_panel = {
            close: function () {

                $('.user-panel').animate(
                        {
                            right: '-230'
                        }
                        , 500, function () {
                            /* $('.panel-handle').addClass('panel-handle-closed').removeClass('panel-handle-opened');
                             $('.arm-pointer').removeClass('glyphicon-chevron-right').addClass('glyphicon-chevron-left');
                             */
                            $('.panel-handle-arm').css('float', 'none');
                            $('.panel-handle').animate({
                                borderBottomRightRadius: '5px',
                                borderTopRightRadius: '5px',
                                borderTopLeftRadius: '15px',
                                borderBottomLeftRadius: '15px'

                            }, 10, function () {

                                $('.arm-pointer').removeClass('glyphicon-chevron-right').addClass('glyphicon-chevron-left')
                                        .css({left: '2px' });

                            });
                            $('.panel-handle-arm').animate({
                                float: 'left',

                                marginLeft: '-13px',
                                marginRight: '+3px',
                                borderRightWidth: '0px',
                                borderLeftWidth: '1px',
                                borderBottomRightRadius: '2px',
                                borderTopRightRadius: '2px',
                                borderTopLeftRadius: '6px',
                                borderBottomLeftRadius: '6px'
                            });


                        }
                );
            },
            open: function () {
                $('.user-panel').animate(
                        {
                            right: '0'
                        }
                        , 500, function () {
                            /*  $('.panel-handle').removeClass('panel-handle-closed').addClass('panel-handle-opened');
                             //<div class="arm-pointer glyphicon glyphicon-chevron-right"></div>
                             $('.arm-pointer').addClass('glyphicon-chevron-right').removeClass('glyphicon-chevron-left');
                             */

                            $('.panel-handle-arm').css('float', 'none');
                            $('.panel-handle').animate({
                                borderBottomRightRadius: '15px',
                                borderTopRightRadius: '15px',
                                borderTopLeftRadius: '5px',
                                borderBottomLeftRadius: '5px'
                            }, 10, function () {

                                $('.arm-pointer').addClass('glyphicon-chevron-right').removeClass('glyphicon-chevron-left')
                                        .css({left: '0px', right: '0px'});
                            });

                            $('.panel-handle-arm').animate({
                                float: 'right',
                                marginRight: '-5px',
                                marginLeft: '0px',
                                borderRightWidth: '1px',
                                borderLeftWidth: '0px',
                                borderBottomRightRadius: '6px',
                                borderTopRightRadius: '6px',
                                borderTopLeftRadius: '2px',
                                borderBottomLeftRadius: '2px'
                            });
                        }
                );
            },
            toggle: function () {
                console.log("ASD");
                var right_distance = $('.user-panel').css('right');
                console.log($('.user-panel').css('right'));
                if (right_distance == '0px')
                    user_panel.close();
                else
                    user_panel.open();
            }


        };

        $(document).ready(function () {
            $('#myTab a:first').tab('show');

            {% for answer in exam_answers %}
                var element = $('#{{ answer.exam.id }}');
                element.html('{{ answer.score }}');
                element.parent().parent().css('backgroundColor', 'rgba(100,100,0,0.25)');
            {% endfor %}

            $('.panel-handle').click(function () {
                user_panel.toggle();
            });
        });
    </script>


    <script type="text/javascript">
        $(document).ready(function () {
            $('.profile-item').click(
                    function (item) {
                        $('.profile-item').removeClass('profile-item-selected');

                        $(item.target).addClass('profile-item-selected');
                        var item_id = item.target.id;
                        var container_name = item_id + '-container';
                        var visible_object = $('.visible')[0];
                        if (visible_object.id == container_name) {
                            return;
                        }

                        $('.visible').fadeOut('fast', function () {
                            $('.visible').removeClass('visible').addClass('hidden');
                            $('#' + container_name).removeClass('hidden').addClass('visible');
                            $('#' + container_name).fadeIn('slow');

                        });

                    }
            )
        });
    </script>
{% endblock %}